; graphics, animation

!ifdef INCLUDE_GFX !eof
!if INCLUDE_GUARD > 0 {
INCLUDE_GFX = 1
}

!zn Gfx {

spellgfx:
;              1111111111222222222233333333334444444444
;    01234567890123456789012345678901234567890123456789
!tx "  swkctfleoBGOHrGhUCPRMbDDDYEVgXWSzpFTTKK#@@@@@@@@"


; acoord = coordinate to flash
; y = frames
; x = end color
flash_anim:
    stx .flash_anim_ecolor
    sty .flash_anim_loops
    jsr print_setup_dst_area    ; TODO redundant?
    ldy acoord
    ldx tbl_area_i_to_screen,y
.flash_anim_loops = * + 1
    ldy #100
-   lda #1
    jsr delay
    lda colorram + POS_AREA,x
    clc
    adc #1
    and #7
    sta colorram + POS_AREA,x
    bne +
    lda vmatrix + POS_AREA,x
    eor #%10000000
    sta vmatrix + POS_AREA,x
+   dey
    bne -
.flash_anim_ecolor = * + 1
    lda #0
    sta colorram + POS_AREA,x
    lda vmatrix + POS_AREA,x
    and #%01111111
    sta vmatrix + POS_AREA,x
    rts

; TODO improve and/or combine
.gfx_anim_all:
GFX_OFFS_POP = * - .gfx_anim_all
gfx_anim_pop:
!tx " .oOX", CHAR_RAY, "X", CHAR_RAY
LEN_gfx_anim_pop = * - gfx_anim_pop
GFX_OFFS_SPELL = * - .gfx_anim_all
gfx_anim_spell:
!tx " .oOOo."
LEN_gfx_anim_spell = * - gfx_anim_spell
GFX_OFFS_SPLAT = * - .gfx_anim_all
gfx_anim_splat:
!tx "0Oo."
LEN_gfx_anim_splat = * - gfx_anim_splat
GFX_OFFS_ATTACK = * - .gfx_anim_all
gfx_anim_attack:
!tx "X", CHAR_RAY, "X", CHAR_RAY
LEN_gfx_anim_attack = * - gfx_anim_attack
GFX_OFFS_BREATH = * - .gfx_anim_all
gfx_anim_breath:
!tx ".uwUWUwu"
LEN_gfx_anim_breath = * - gfx_anim_breath

tbl_gfx_anim_pos0:
!by GFX_OFFS_POP + LEN_gfx_anim_pop - 1
!by GFX_OFFS_SPELL + LEN_gfx_anim_spell - 1
!by GFX_OFFS_SPLAT + LEN_gfx_anim_splat - 1
!by GFX_OFFS_ATTACK + LEN_gfx_anim_attack - 1
!by GFX_OFFS_BREATH + LEN_gfx_anim_breath - 1
tbl_gfx_anim_pos1:
!by GFX_OFFS_POP - 1, GFX_OFFS_SPELL - 1, GFX_OFFS_SPLAT - 1, GFX_OFFS_ATTACK - 1
!by GFX_OFFS_BREATH - 1

GFX_ANIM_POP = 0
GFX_ANIM_SPELL = 1
GFX_ANIM_SPLAT = 2
GFX_ANIM_ATTACK = 3
GFX_ANIM_BREATH = 4

; in:
; acoord = target coord
; x = color
; y = GFX_ANIM_x
gfx_animation:
    stx .gfx_animation_color
    lda tbl_gfx_anim_pos0,y
    sta .gfx_animation_pos0
    lda tbl_gfx_anim_pos1,y
    sta .gfx_animation_pos1
    jsr print_setup_dst_area
    ldy acoord
    ldx tbl_area_i_to_screen,y
.gfx_animation_color = * + 1
    lda #COLOR_BLUE
    sta colorram + POS_AREA,x
.gfx_animation_pos0 = * + 1
    ldy #4
-   lda .gfx_anim_all,y
    sta vmatrix + POS_AREA,x
    lda #4
    jsr delay
    dey
.gfx_animation_pos1 = * + 1
    cpy #0
    bne -
    ldy acoord
    jsr arena_draw_square
    rts

} ; !zn Gfx
