; splash screen

!ifdef INCLUDE_SPLASH !eof
!if INCLUDE_GUARD > 0 {
INCLUDE_SPLASH = 1
}

!zn Splash {

.splash_line_0:
!tx "* ", TTOK_CHAOS_, "*", 0
.splash_line_1:
!tx "The Battle of ", TTOK_WIZARD, "s", 0
.splash_line_2:
!tx "by Julian Gollop", 0

.splash_pos_addr_l:
!by <(vmatrix + POSY_STATUSLINE2 * COLS + 2)
!by <(vmatrix + POSY_STATUSLINE1 * COLS)
!by <(vmatrix + POSY_STATUSLINE0 * COLS + 5)
.splash_pos_addr_h:
!by >(vmatrix + POSY_STATUSLINE2 * COLS + 2)
!by >(vmatrix + POSY_STATUSLINE1 * COLS)
!by >(vmatrix + POSY_STATUSLINE0 * COLS + 5)

show_splash:
    jsr print_clear_all
    lda #COLOR_BLACK
    jsr set_arena_border_color

    lda #COLOR_WHITE
    sta color

    lda #<.splash_line_0
    sta zptxt
    lda #>.splash_line_0
    sta zptxth

    ldx #2
-   stx zptmp
    lda .splash_pos_addr_h,x
    tay
    lda .splash_pos_addr_l,x
    tax
    jsr print_packed_xy

    ldx zptmp
    dex
    bpl -

    ; enable screen
    lda #(((vmatrix & $200) >> 2) | COLS)
    sta $9002

-   jsr get_input
    beq -
    cmp #INPUT_SELECT
    bne -

    jsr print_clear_status
    rts

} ; !zn Splash
