; text printing routines and compressed text

!ifdef INCLUDE_TEXT !eof
!if INCLUDE_GUARD > 0 {
INCLUDE_TEXT = 1
}

!zn Text {

text_noyes:
!tx "No", 0
text_yes:
!tx "Yes", 0
!tx 0

.text_status3:
.text_oor:
STATUS3_OOR = 0
!tx "Out of range",0
.text_nolos:
STATUS3_NOLOS = 1
!tx "No line of sight",0
.text_adjacent:
STATUS3_ADJACENT = 2
!tx "Adjacent",0
.text_ready:
STATUS3_READY = 3
!tx "Ready",0
.text_undead_cannot:
STATUS3_UNDEAD = 4
!tx "Undead - cannot attack",0

.tbl_text_status3:
!by <.text_oor
!by <.text_nolos
!by <.text_adjacent
!by <.text_ready
!by <.text_undead_cannot
.tbl_text_status3h:
!by >.text_oor
!by >.text_nolos
!by >.text_adjacent
!by >.text_ready
!by >.text_undead_cannot


TTOK_GIANT = $80
TTOK_DARK_ = $81
TTOK_MAGIC_ = $82
TTOK_WOOD = $83
TTOK_SHADOW_ = $84
TTOK_LAW_ = $85
TTOK_CHAOS_ = $86
TTOK__DRAGON = $87
TTOK_WIZARD = $88
TTOK_SPELL_ = $89
TTOK_CONTINUE = $8a
TTOK_CANCEL_ = $8b

text_tok_base:
text_tok_giant:
!tx "Giant", 0
text_tok_dark_:
!tx "Dark ", 0
text_tok_magic_:
!tx "Magic ", 0
text_tok_wood:
!tx "Wood", 0
text_tok_shadow_:
!tx "Shadow ", 0
text_tok_law_:
!tx "Law ", 0
text_tok_chaos_:
!tx "Chaos ", 0
text_tok__dragon:
!tx " Dragon", 0
text_tok_wizard:
!tx "Wizard", 0
text_tok_spell_:
!tx "Spell ", 0
text_tok_continue:
!tx "Continue", 0
text_tok_cancel_:
!tx "Cancel ",0

!if * - text_tok_base > $100 {
!error "text_tok_base is too large"
!error * - text_tok_base - 100
}

text_tok_tbl:
!by text_tok_giant - text_tok_base
!by text_tok_dark_ - text_tok_base
!by text_tok_magic_ - text_tok_base
!by text_tok_wood - text_tok_base
!by text_tok_shadow_ - text_tok_base
!by text_tok_law_ - text_tok_base
!by text_tok_chaos_ - text_tok_base
!by text_tok__dragon - text_tok_base
!by text_tok_wizard - text_tok_base
!by text_tok_spell_  - text_tok_base
!by text_tok_continue  - text_tok_base
!by text_tok_cancel_  - text_tok_base


spellnames_packed:
spellname_0:
!tx 0
spellname_1:
!tx "Disbelieve", 0
spellname_2:
!tx "King Cobra", 0
spellname_3:
!tx "Dire Wolf", 0
spellname_4:
!tx "Goblin", 0
spellname_5:
!tx "Crocodile", 0
spellname_6:
!tx "Troll", 0
spellname_7:
!tx "Faun", 0
spellname_8:
!tx "Lion", 0
spellname_9:
!tx "Elf", 0
spellname_10:
!tx "Orc", 0
spellname_11:
!tx "Bear", 0
spellname_12:
!tx "Gorilla", 0
spellname_13:
!tx "Ogre", 0
spellname_14:
!tx "Hydra", 0
spellname_15:
!tx TTOK_GIANT, " Rat", 0
spellname_16:
!tx TTOK_GIANT, 0
spellname_17:
!tx "Horse", 0
spellname_18:
!tx "Unicorn", 0
spellname_19:
!tx "Centaur", 0
spellname_20:
!tx "Pegasus", 0
spellname_21:
!tx "Gryphon", 0
spellname_22:
!tx "Manticore", 0
spellname_23:
!tx "Bat", 0
spellname_24:
!tx "Green", TTOK__DRAGON, 0
spellname_25:
!tx "Red", TTOK__DRAGON, 0
spellname_26:
!tx "Golden", TTOK__DRAGON, 0
spellname_27:
!tx "Harpy", 0
spellname_28:
!tx "Eagle", 0
spellname_29:
!tx "Vampire", 0
spellname_30:
!tx "Ghost", 0
spellname_31:
!tx "Spectre", 0
spellname_32:
!tx "Wraith", 0
spellname_33:
!tx "Skeleton", 0
spellname_34:
!tx "Zombie", 0
spellname_35:
!tx "Gooey Blob", 0
spellname_36:
!tx TTOK_MAGIC_, "Fire", 0
spellname_37:
!tx TTOK_MAGIC_, TTOK_WOOD, 0
spellname_38:
!tx TTOK_SHADOW_, TTOK_WOOD, 0
spellname_39:
!tx TTOK_MAGIC_, "Castle", 0
spellname_40:
!tx TTOK_DARK_, "Citadel", 0
spellname_41:
!tx "Wall", 0
spellname_42:
!tx TTOK_MAGIC_, "Bolt", 0
spellname_43:
!tx "Lightning", 0
spellname_44:
!tx "Vengeance", 0
spellname_45:
!tx "Decree", 0
spellname_46:
!tx TTOK_DARK_, "Power", 0
spellname_47:
!tx "Justice", 0
spellname_48:
!tx TTOK_MAGIC_, "Shield", 0
spellname_49:
!tx TTOK_MAGIC_, "Armour", 0
spellname_50:
!tx TTOK_MAGIC_, "Sword", 0
spellname_51:
!tx TTOK_MAGIC_, "Knife", 0
spellname_52:
!tx TTOK_MAGIC_, "Bow", 0
spellname_53:
!tx TTOK_MAGIC_, "Wings", 0
spellname_54:
!tx TTOK_LAW_, "1", 0
spellname_55:
!tx TTOK_LAW_, "2", 0
spellname_56:
!tx TTOK_CHAOS_, "1", 0
spellname_57:
!tx TTOK_CHAOS_, "2", 0
spellname_58:
!tx TTOK_SHADOW_, "Form", 0
spellname_59:
!tx "Subversion", 0
spellname_60:
!tx "Raise Dead", 0
spellname_61:
!tx "Turmoil", 0

!if * - spellnames_packed > $200 {
!error "spellnames_packed is too large"
!error * - spellnames_packed - 200
}

; nnnnnnn876543210
;        00000000n
;       11111111nn
;      22222222nnn
;     33333333nnnn
;    44444444nnnnn
;   55555555nnnnnn
;  66666666nnnnnnn
; 7777777788888888

;      76543210 76543210 76543210 76543210 76543210 76543210 76543210 76543210 76543210
; 0 -> 87654321 0
; 1 ->           8765432 10
; 2 ->                     876543 210
; 3 ->                               87654 3210
; 4 ->                                         8765 43210
; 5 ->                                                   876 543210
; 6 ->                                                             87 6543210
; 7 ->                                                                       8 76543210

!macro spellnameb {
!set SPELLNAMEBITS = 0
!set SPELLNAMETMP = 0
}

!macro spellnamed .v {
!by (SPELLNAMETMP << (8 - SPELLNAMEBITS)) | (.v >> (9 - 8 + SPELLNAMEBITS)) & ((1 << (8 - SPELLNAMEBITS)) - 1)
!set SPELLNAMEBITS = 9 - (8 - SPELLNAMEBITS)
!if SPELLNAMEBITS >= 8 {
    !by (.v >> (SPELLNAMEBITS - 8)) & $ff
    !set SPELLNAMEBITS = SPELLNAMEBITS - 8
}
!set SPELLNAMETMP = (.v & ((1 << SPELLNAMEBITS) - 1))
}

!macro spellnamee {
!by (SPELLNAMETMP << (8 - SPELLNAMEBITS))
}

spellname_tbl:
+spellnameb
+spellnamed spellname_0 - spellnames_packed
+spellnamed spellname_1 - spellnames_packed
+spellnamed spellname_2 - spellnames_packed
+spellnamed spellname_3 - spellnames_packed
+spellnamed spellname_4 - spellnames_packed
+spellnamed spellname_5 - spellnames_packed
+spellnamed spellname_6 - spellnames_packed
+spellnamed spellname_7 - spellnames_packed
+spellnamed spellname_8 - spellnames_packed
+spellnamed spellname_9 - spellnames_packed
+spellnamed spellname_10 - spellnames_packed
+spellnamed spellname_11 - spellnames_packed
+spellnamed spellname_12 - spellnames_packed
+spellnamed spellname_13 - spellnames_packed
+spellnamed spellname_14 - spellnames_packed
+spellnamed spellname_15 - spellnames_packed
+spellnamed spellname_16 - spellnames_packed
+spellnamed spellname_17 - spellnames_packed
+spellnamed spellname_18 - spellnames_packed
+spellnamed spellname_19 - spellnames_packed
+spellnamed spellname_20 - spellnames_packed
+spellnamed spellname_21 - spellnames_packed
+spellnamed spellname_22 - spellnames_packed
+spellnamed spellname_23 - spellnames_packed
+spellnamed spellname_24 - spellnames_packed
+spellnamed spellname_25 - spellnames_packed
+spellnamed spellname_26 - spellnames_packed
+spellnamed spellname_27 - spellnames_packed
+spellnamed spellname_28 - spellnames_packed
+spellnamed spellname_29 - spellnames_packed
+spellnamed spellname_30 - spellnames_packed
+spellnamed spellname_31 - spellnames_packed
+spellnamed spellname_32 - spellnames_packed
+spellnamed spellname_33 - spellnames_packed
+spellnamed spellname_34 - spellnames_packed
+spellnamed spellname_35 - spellnames_packed
+spellnamed spellname_36 - spellnames_packed
+spellnamed spellname_37 - spellnames_packed
+spellnamed spellname_38 - spellnames_packed
+spellnamed spellname_39 - spellnames_packed
+spellnamed spellname_40 - spellnames_packed
+spellnamed spellname_41 - spellnames_packed
+spellnamed spellname_42 - spellnames_packed
+spellnamed spellname_43 - spellnames_packed
+spellnamed spellname_44 - spellnames_packed
+spellnamed spellname_45 - spellnames_packed
+spellnamed spellname_46 - spellnames_packed
+spellnamed spellname_47 - spellnames_packed
+spellnamed spellname_48 - spellnames_packed
+spellnamed spellname_49 - spellnames_packed
+spellnamed spellname_50 - spellnames_packed
+spellnamed spellname_51 - spellnames_packed
+spellnamed spellname_52 - spellnames_packed
+spellnamed spellname_53 - spellnames_packed
+spellnamed spellname_54 - spellnames_packed
+spellnamed spellname_55 - spellnames_packed
+spellnamed spellname_56 - spellnames_packed
+spellnamed spellname_57 - spellnames_packed
+spellnamed spellname_58 - spellnames_packed
+spellnamed spellname_59 - spellnames_packed
+spellnamed spellname_60 - spellnames_packed
+spellnamed spellname_61 - spellnames_packed
+spellnamee


; in:
; print_dst_l1/2,3/4 -> destination
; a = num
; x = offset
; color = color
; out:
; x++
print_num_dst_x:
    clc
    adc #'0'
; a = char
print_char_dst_x:
.print_dst_l1 = * + 1
.print_dst_h1 = * + 2
    sta vmatrix,x
    lda color
.print_dst_l2 = * + 1
.print_dst_h2 = * + 2
    sta colorram,x
    inx
    rts


; in:
; a = number to print
; x = offset
; color = color
print_number:
    cmp #100
    bcc ++
    ldy #-1
-   iny
    sec
    sbc #100
    bcs -
    pha
    tya
    jsr print_num_dst_x
    pla
    clc
    adc #100
    bpl +   ; bra
++
    cmp #10
    bcc ++
+   ldy #-1
-   iny
    sec
    sbc #10
    bcs -
    pha
    tya
    jsr print_num_dst_x
    pla
    clc
    adc #10
++
    jsr print_num_dst_x
    rts


print_setup_dst_next_line:
    lda #COLS
    ; FALL THROUGH

; a = chars to advance
print_setup_dst_add_a:
    clc
    adc .print_dst_l1
    sta .print_dst_l1
    sta .print_dst_l2
    bcc +
    inc .print_dst_h1
    inc .print_dst_h2
+   rts

; a = -chars_to_back
print_setup_dst_sub_a:
    clc
    adc .print_dst_l1
    sta .print_dst_l1
    sta .print_dst_l2
    bcs +
    dec .print_dst_h1
    dec .print_dst_h2
+   rts

print_setup_dst_statusline:
    ldx #<(vmatrix + POSY_STATUSLINE0 * COLS)
    ldy #>(vmatrix + POSY_STATUSLINE0 * COLS)
    bne print_setup_dst_xy  ; bra

print_setup_dst_statusline1:
    ldx #<(vmatrix + POSY_STATUSLINE1 * COLS)
    ldy #>(vmatrix + POSY_STATUSLINE1 * COLS)
    bne print_setup_dst_xy  ; bra

print_setup_dst_statusline2:
    ldx #<(vmatrix + POSY_STATUSLINE2 * COLS)
    ldy #>(vmatrix + POSY_STATUSLINE2 * COLS)
    bne print_setup_dst_xy  ; bra

print_setup_dst_area:
    ldx #<(vmatrix + POS_AREA)
    ldy #>(vmatrix + POS_AREA)
    ; FALL THROUGH

; x:y -> destination
print_setup_dst_xy:
    stx .print_dst_l1
    stx .print_dst_l2
    sty .print_dst_h1
    pha
    tya
    clc
    adc #>(colorram - vmatrix)
    sta .print_dst_h2
    pla
    rts

; in:
; zptxt -> text to print
; x:y -> destination
; color = color
print_packed_xy:
    jsr print_setup_dst_xy

; in:
; zptxt -> text to print
; color = color
; out:
; zptxt -> byte after terminating 0
print_packed_dst_ready:
    ldx #0
print_packed_dst_ready_x:
    ldy #0
--  lda (zptxt),y
    beq +++
    bpl ++
    sty .print_tmp_y
    tay
    lda text_tok_tbl - $80,y
    tay
-   lda text_tok_base,y
    beq +
    jsr print_char_dst_x
    iny
    bne -   ; bra
.print_tmp_y = * + 1
+   ldy #0
    iny
    bne --  ; bra
++  jsr print_char_dst_x
    iny
    bne --  ; bra
+++
    iny
    tya
    clc
    adc zptxt
    sta zptxt
    bcc +
    inc zptxth
+   rts


; in:
; a = spell index
; x:y = destination
; color = color
print_spellname:
    jsr print_setup_dst_xy

; in:
; a = spell index
; color = color
print_spellname_dst_ready:
    ; unpack 9b offset to 16b addr
    pha
    pha
    lsr
    lsr
    lsr
    sta zptxt
    pla
    clc
    adc zptxt
    ; a = (index / 8b) * 9b/tblentry
    tay ; y -> spellname_tbl offset
    pla
    and #7
    tax ; bit index

    lda #9
    sta zploops
    lda #0
    sta zptxt
    sta zptxth
-   lda bitmask,x
    bne +
    iny
    ldx #0
    lda bitmask
+   clc
    and spellname_tbl,y
    beq +
    sec
+   rol zptxt
    rol zptxth
    inx
    dec zploops
    bne -

    lda zptxt
    clc
    adc #<spellnames_packed
    sta zptxt
    lda zptxth
    adc #>spellnames_packed
    sta zptxth

    jsr print_packed_dst_ready
    rts


; y = wizard index
print_wizard_name:
    ldx #0
; x = offs
print_wizard_name_offs_x:
    ; FIXME shorter names
    lda wizard_color,y
    sta color
    lda #PNAME_LEN
    sta zploops
    tya
    asl
    asl
    asl
    tay
-   lda player_names,y
    jsr print_char_dst_x
    iny
    dec zploops
    bne -
    rts


print_clear_all:
    jsr print_clear_status
    jsr print_clear_info
    ; FALL THROUGH

print_clear_area:
    pha
    ldx #0
--  ldy #AREA_W - 1
    lda #COLOR_BLACK
-   sta colorram + POS_AREA,x
    inx
    dey
    bpl -
    txa
    clc
    adc #COLS - AREA_W
    tax
    cpx #AREA_H * COLS
    bne --
    pla
    rts

print_clear_status:
    pha
    ldx #COLS * 4
    lda #COLOR_BLACK
-   sta colorram + POSY_STATUSLINE0 * COLS - 1, x
    dex
    bne -
    pla
    rts

print_clear_status12:
    ldx #COLS * 2
    bne print_clear_status1_x   ; bra
print_clear_status123:
    ldx #COLS * 3
print_clear_status1_x:
    lda #COLOR_BLACK
-   sta colorram + POSY_STATUSLINE1 * COLS - 1,x
    dex
    bne -
    rts

print_clear_status2:
    ldx #COLS
    bne print_clear_status2_x   ; bra
print_clear_status23:
    ldx #COLS * 2
print_clear_status2_x:
    lda #COLOR_BLACK
-   sta colorram + POSY_STATUSLINE2 * COLS - 1,x
    dex
    bne -
    rts

print_clear_status3:
    pha
    ldx #COLS
    lda #COLOR_BLACK
-   sta colorram + POSY_STATUSLINE3 * COLS - 1,x
    dex
    bne -
    pla
    rts

print_clear_info:
    pha
    ldx #0
--  ldy #INFOLINE_W - 1
    lda #COLOR_BLACK
-   sta colorram + POS_INFOLINE,x
    sta colorram + POS_INFOLINE + (INFOLINE_H / 2) * COLS,x
    inx
    dey
    bpl -
    txa
    clc
    adc #COLS - INFOLINE_W
    tax
    cpx #(INFOLINE_H / 2) * COLS
    bne --
    pla
    rts


; in:
; y = status text index (STATUS3_*)
; out:
; C = 0
print_text_status3:
    lda .tbl_text_status3,y
    sta zptxt
    lda .tbl_text_status3h,y
    sta zptxth
    lda #COLOR_YELLOW
    sta color
    ldx #<(vmatrix + POSY_STATUSLINE3 * COLS)
    ldy #>(vmatrix + POSY_STATUSLINE3 * COLS)
    jsr print_setup_dst_xy
    jsr print_packed_dst_ready
    clc
    rts


; a = color
set_arena_border_color:
    ldx #AREA_W + 1
-   sta colorram,x
    sta colorram + COLS * (AREA_H + 1),x
    dex
    bpl -

    ldx #AREA_H - 1
    ldy #0
    clc
-   sta colorram + COLS * 1,y
    pha
    tya
    adc #AREA_W + 1
    tay
    pla
    sta colorram + COLS * 1,y
    pha
    tya
    adc #COLS - (AREA_W + 1)
    tay
    pla
    dex
    bpl -
    rts

; y = menuitem
text_erase_cursor:
    ldx text_line_area_offs,y
    lda #' '
    jsr print_char_dst_x
    rts

text_line_area_offs:
!for .i, 0, AREA_H - 1 {
!by .i * COLS
}

} ; !zn Text
